﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Browser;
using PerpetuumSoft.ReportingServices.Viewer.Client.Utils;

namespace SilverlightApplication
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            reportViewer.ParametersProcessing += new EventHandler<ParametersProcessingEventArgs>(reportViewer_ParametersProcessing);
            reportViewer.ParameterVisibilityChanging += new EventHandler<ParameterVisibilityChangingEventArgs>(reportViewer_ParameterVisibilityChanging);
        }

        void reportViewer_ParameterVisibilityChanging(object sender, ParameterVisibilityChangingEventArgs e)
        {
            if (e.ParametersCollection != null)
            {
                foreach (var item in e.ParametersCollection)
                {
                    if (item.Nullable)
                        item.Visibility = false;
                }
            }
        }

        void reportViewer_ParametersProcessing(object sender, ParametersProcessingEventArgs e)
        {
            if (e.Collection.Count(p => p.Name == "ReportParameter3") > 0)
            {
                e.Collection.First(p => p.Name == "ReportParameter3").Value = "value from code";
            }
            if (e.Collection.Count(p => p.Name == "ReportParameter4") > 0)
            {
                int param4Value = 0;
                if (int.TryParse(e.Collection.First(p => p.Name == "ReportParameter4").Value, out param4Value))
                {
                    if (!(param4Value > 3 && param4Value < 10))
                    {
                        e.CancelRender = true;
                        e.ShowParametersPanel = true;
                        ChildWindow1 frm = new ChildWindow1();
                        frm.Show();
                    }
                }
            }
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            reportViewer.ReportName = "/AdventureWorks 2008 Sample Reports/Report List 2008";

            if (HtmlPage.IsEnabled == false)
            {
                reportViewer.ServiceUrl = "http://localhost:51286/ReportService.svc";
                reportViewer.DebugMode = DebugModeEnum.Full;
            }
            else
            {
                SilverlightInitParamsHelper initParamsHelper =
                    new SilverlightInitParamsHelper(
                        HtmlPage.Plugin.GetProperty("initParams").ToString());
                reportViewer.ServiceUrl = initParamsHelper.ServiceUrl;
                reportViewer.DebugMode = initParamsHelper.DebugMode;
            }

            reportViewer.SSRSRenderingCulture = _ssrsLocale.Text;

            reportViewer.ApplyTemplate();
            reportViewer.RenderDocument();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            reportViewer.StopRendering();
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            reportViewer.ShowParametersPanel();
        }

    }
}
